module.exports = function (runtime, scope) {

    let jq = {};
    let JQ = com.stardust.autojs.JQ;
    jq.JQ = JQ;
    for(let k in JQ){
        jq[k] = JQ[k];
    }
    jq.v = 2.3301;


    {
        jq.funcTrans = function (func) {
            return function () {
                return func();
            }
        }

        jq.sleepEx = function (ms) {
            let start = Date.now();
            while (Date.now() - start < ms) {
                try {
                    sleep(100);
                } catch (e) {}
            }
        };

        jq.isJsonEmpty = function (input) {
            return Object.keys(input).length == 0;
        };

        jq.isUndef = function (input) {
            return typeof input == "undefined";
        };

        jq.trim = function (input) {
            return input.replace(/^\s+|\s+$/gm, '');
        }

        jq.padLeft = function (num, total, pad) {
            total = total || 2;
            return (Array(total).join(pad || 0) + num).slice(-total);
        }

        jq.fmtDate = function (obj, full) {
            let date = new Date(obj);
            let y = 1900 + date.getYear();
            return y + "-" + jq.padLeft(date.getMonth() + 1) + "-" + jq.padLeft(date.getDate()) + (full ? (" " + jq.padLeft(date.getHours()) + ":" + jq.padLeft(date.getMinutes()) + ":" + jq.padLeft(date.getSeconds())) : "");
        };

        jq.waitUntil = function (func, timeout, options) {
            options = options || {};
            timeout = timeout || 30 * 1000;
            options.interval = options.interval || 100;
            return JQ.waitUntil(jq.funcTrans(func), timeout, options.interval)
        }

        jq.ckToJson = function (ck) {
            ck = ck + ";"
            let cookies = ck.split(";");
            let jsonStr = "";
            for (let i = 0; i < cookies.length - 1; i++) {
                if (cookies[i].split("=").length > 0) {
                    jsonStr += ",\"" + cookies[i].split("=")[0].trim() + "\":\"" + cookies[i].split("=")[1] + "\"";
                }
            }
            return JSON.parse("{" + jsonStr.substr(1).replace("\\", "") + "}");
        }

        jq.today = function () {
            return new Date(new Date().toDateString()).getTime();
        }

        jq.checkSplit = function (input) {
            input = (input || "") + "";
            let res = input.replace(/，/g, ",").replace(/;/g, ",").replace(/；/g, ",");
            return res;
        }

        jq.removeEmpty = function (array, needTrim) {
            for (var i = 0; i < array.length; i++) {
                let item = "";
                if (array[i] == null || typeof (array[i]) == "undefined" || ((item = jq.trim(array[i])) == "")) {
                    array.splice(i, 1);
                    i = i - 1;
                    continue;
                }
                if (needTrim) {
                    array[i] = item;
                }
            }
            return array;
        }

        jq.split = function (input, needTrim) {
            input = jq.checkSplit(input);
            return jq.removeEmpty(input ? input.split(/[,\n]/) : [], needTrim);
        }
    }


    {
        jq.isXiaomi = function () {
            return device.brand.toLowerCase() == "xiaomi";
        }

        jq.isVivo = function () {
            return device.brand.toLowerCase() == "vivo";
        }

        jq.isMeizu = function () {
            return device.brand.toLowerCase() == "meizu";
        }

        jq.isHuawei = function () {
            let name = device.brand.toLowerCase();
            return name == "huawei" || name == "honor";
        }

        jq.isSamsung = function () {
            return device.brand.toLowerCase() == "samsung";
        }
    }

    {
        jq.swipeUp = function (margin, delay, options) {
            margin = margin || 0.17;
            delay = delay || 400;
            options = options || {};
            options.divide = options.divide || JQ.ri(15, 5);
            options.simple = options.simple || false;
            options.endMargin = options.endMargin || JQ.rd(0.15, 0.14);

            let cx = JQ.dw();
            let cy = JQ.dh();
            margin = margin > 1 ? margin : (cy * margin);
            margin = margin + cy * JQ.rd(options.simple ? 0.01 : 0.07, 0);

            let startX = cx * JQ.rd(0.3, 0.65);
            let startY = cy - margin;

            let endX = cx * JQ.rd(0.9, 0.45);
            let endY = options.simple ? cy * options.endMargin : Math.min(cy * JQ.rd(0.15, 0.45), cy - margin - cy * 0.3); //至少有一定的y高度

            let delX = endX - startX;
            let delY = startY - endY;

            let k = delY / delX / delX;

            let perX = delX / options.divide;

            let points = [
                [startX, startY]
            ];

            for (let i = 0; i < options.divide; i++) {
                let x = startX + (i + 1) * perX;
                let y = k * (x - endX) * (x - endX) + endY;
                points.push([x, y]);
            }

            gesture(delay, points);
        };

        jq.swipeDown = function (margin, delay, options) {
            margin = margin || 0.2;
            delay = delay || 400;
            options = options || {};
            options.divide = options.divide || JQ.ri(15, 5);
            options.simple = options.simple || false;
            options.endMargin = options.endMargin || JQ.rd(0.83, 0.84);

            let cx = JQ.dw();
            let cy = JQ.dh();
            margin = margin > 1 ? margin : (cy * margin);
            margin = margin + cy * JQ.rd(options.simple ? 0.01 : 0.07, 0);

            let startX = cx * JQ.rd(0.8, 0.45);
            let startY = margin;

            let endX = cx * JQ.rd(0.3, 0.75);
            let endY = options.simple ? cy * options.endMargin : Math.max(cy * JQ.rd(0.8, 0.55), cy - margin - cy * 0.3);

            let delX = endX - startX;
            let delY = endY - startY;

            let k = delY / delX / delX;

            let perX = delX / options.divide;

            let points = [
                [startX, startY]
            ];

            for (let i = 0; i < options.divide; i++) {
                let x = startX + (i + 1) * perX;
                let y = k * (x - startX) * (x - startX) + startY;
                points.push([x, y]);
            }

            gesture(delay, points);
        };

        jq.showCtrl = function (func, options) {
            options = options || {};
            options.swipeTimes = options.swipeTimes || 5;
            options.dirUp = jq.isUndef(options.dirUp) ? true : options.dirUp;
            options.top = jq.isUndef(options.top) ? 0.2 : options.top;
            options.bottom = options.bottom || 0.8;
            options.oneWay = jq.isUndef(options.oneWay) ? true : options.oneWay;
            return JQ.showCtrl(jq.funcTrans(func), options.swipeTimes, !!options.dirUp, !!options.oneWay, options.top, options.bottom);
        }

        jq.backToMain = function (func, options) {
            options = options || {};
            JQ.backToMain(jq.funcTrans(func), options.max || 0, options.interval || 0);
        }

        jq.clickPt = function (point, wait, ow, oh) {
            ow = ow || 10;
            oh = oh || 10;
            if (point) {
                let x = point.x + ow;
                let y = point.y + oh;
                if(x >= 0 && y >= 0 && jq.dw() >= x && jq.dh() >= y){
                    click(x, y);
                    jq.sleepEx(wait);
                    return true;
                }

            }
            return false;
        };
    }

    {
        jq.log = function (msg, fn, options) {
            options = options || {};
            if (util.showMsg || util.test) {
                toast(msg);
            }
            try {
                let date = jq.fmtDate(Date());
                fn = fn || ("/sdcard/001/log_" + date + ".txt");
                files.createWithDirs(fn);
                let d = new Date();
                let time = jq.padLeft(d.getHours()) + ":" + jq.padLeft(d.getMinutes()) + ":" + jq.padLeft(d.getSeconds()) + " ";
                files.append(fn, time + msg + "\r\n");
            } catch (e) {
                msg = e;
            }
            if(options.onlySelf){
                return
            }
            if(options.level == "warn"){
                console.warn(msg)
            }else if(options.level == "error"){
                console.error(msg)
            }else if(options.level == "info"){
                console.info(msg)
            }else if(options.level == "verbose"){
                console.verbose(msg)
            }else{
                log(msg);
            }
        }

        jq.logJ = function (jsonMsg) {
            jq.log(JSON.stringify(jsonMsg));
        }

        jq.loadHtml = function (url, sucFunc) {
            try {
                let r = http.get(url);
                if (r.statusCode == 200) {
                    let html = r.body.string();
                    sucFunc && sucFunc(html, r);
                    return html;
                }
            } catch (e) {
                log(e.message);
            }
        }

        jq.getStorage = function (key) {
            let s = storages.create("fw");
            return s.get(key) || {};
        };

        jq.setStorage = function (key, obj) {
            let s = storages.create("fw");
            s.put(key, obj);
        }

        jq.getCfg = function (key) {
            return jq.getStorage("fw_cfg_" + key)
        }

        jq.setCfg = function (obj, key) {
            jq.setStorage("fw_cfg_" + key, obj);
        }

        jq.getTO = function (key) {
            let obj = jq.getStorage("fw_to_" + key);
            if (obj && obj.date == new Date().getDate()) {
                return obj;
            }
            return {
                date: new Date().getDate()
            };
        }

        jq.setTO = function (obj, key) {
            jq.setStorage("fw_to_" + key, obj);
        }

        jq.fillUI = function (uiNode, v) {
            if (!uiNode || !v) {
                return;
            }
            uiNode.removeAllViews();
            uiNode.addView(ui.inflate(v), new android.widget.FrameLayout.LayoutParams(-1, -1));
        }

        jq.readInfo = function (fn) {
            try {
                files.createWithDirs(fn);
                let s = files.read(fn);
                return JSON.parse(s) || {};
            } catch (e) {
                return {};
            }
        }

        jq.writeInfo = function (info, fn) {
            try {
                files.createWithDirs(fn);
                files.write(fn, JSON.stringify(info));
            } catch (e) {}
        }
    }

    return jq;
}
